(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   File time changer (UNICODE!!!)                                       ***
 ***   Version [1.10]                               {Last mod 2003-08-07}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)

program FTchange;
{.$APPTYPE CONSOLE}
uses
  Windows,
  shlobj,
  ActiveX,
  Messages;

{$R MAIN.RES}

function ErrorLog(pw: PWideChar): BOOL; stdcall; forward;
{$INCLUDE .\Include\FormatString.pas}
{$INCLUDE .\Include\SetFT.pas}
{$INCLUDE .\Include\BrowseForFolder.pas}
{$INCLUDE .\Include\GetFont.pas}

const
  IDD_DIALOG1 = 101;
  IDI_ICON1 = 102;
  IDC_EDIT_YEAR = 1000;
  IDC_EDIT_MONTH = 1001;
  IDC_EDIT_PATH = 1002;
  IDC_BUTTON_CHOOSEPATH = 1003;
  IDC_EDIT_DAY = 1004;
  IDC_EDIT_HOUR = 1005;
  IDC_EDIT_MINUTE = 1006;
  IDC_EDIT_SECOND = 1007;
  IDC_LIST1 = 1008;
  IDC_BUTTON_CURRTIME = 1009;
  IDC_BUTTON_CURRMONTH = 1010;
  IDC_BUTTON_CURRYEAR = 1011;
  IDC_BUTTON_HELP = 1012;
  IDC_CHECK_SMODE = 1013;
  IDC_CHECK_PROBLEMS = 1014;

const
  helptext =
    'FTchange can be used to change the filetime in a directory recursively.' + #13#10#13#10 +
    'It fully supports Unicode and will perhaps not run properly on Win 9x!' + #13#10#13#10 +
    '________________________________________________________________' + #13#10 +
    'Current time: Presets the current time.' + #13#10 +
    'Current month: Presets current date with day of month set to 1. Time is 0:00.' + #13#10 +
    'Current year: Same as "Current month" but also month is set to 1.' + #13#10 +
    'Special mode: Will only reset file times to 0:00. Date is left alone.' + #13#10 +
    'Show only problems: Will only show files/dirs where problems occured.' + #13#10 +
    'Apply: Applies the changes to the selected directory.' + #13#10 +
    '________________________________________________________________' + #13#10 +
    #13#10 +
    'Have a lot of fun with this small program,' + #13#10 + '-=Assarbad=-';

var
  hDlg: HWND = 0;
  appIcon: HICON = 0;

type
  PThreadData = ^TThreadData;
  TThreadData = record
    ft,
      la,
      lw: FILETIME; // in GMT!
    Path: PWideChar;
    ShowAllFiles,
      SpecialMode: Boolean;
  end;

function DirExists(FileName: string): Boolean;
var
  HiDate, LoDate: word;
  Handle: THandle;
  FindData: TWin32FindData;
  LocalFileTime: FILETIME;
begin
  result := false;
  if FileName <> '' then
    if FileName[Length(FileName)] = '\' then
      FileName[Length(FileName)] := #0;
  Handle := FindFirstFile(@FileName[1], FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
    begin
      FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
      result := FileTimeToDosDateTime(LocalFileTime, HiDate, LoDate);
    end;
  end;
end;

function EnumChildSetFonts(hwnd: HWND; lParam: LPARAM): BOOL; stdcall;
begin
  result := True;
// For any of the controls here, let's set the font :)
  case GetDlgCtrlID(hwnd) of
    IDC_EDIT_DAY,
      IDC_EDIT_HOUR,
      IDC_EDIT_MINUTE,
      IDC_EDIT_SECOND,
      IDC_EDIT_YEAR,
      IDC_EDIT_MONTH:
      SendMessage(hwnd, WM_SETFONT, lParam, ord(TRUE));
  end;
  case GetDlgCtrlID(hwnd) of
    IDC_EDIT_YEAR:
      SendMessage(hwnd, EM_SETLIMITTEXT, 4, 0);
    IDC_EDIT_DAY,
      IDC_EDIT_HOUR,
      IDC_EDIT_MINUTE,
      IDC_EDIT_SECOND,
      IDC_EDIT_MONTH:
      SendMessage(hwnd, EM_SETLIMITTEXT, 2, 0);
  end;
end;

procedure SetTimeInEdits(hwnd: HWND; st: SYSTEMTIME);
{
var
  ft:FILETIME;
}
begin
{
  SystemTimeToFileTime(st, ft);
  LocalFiletimeToFileTime(ft, ft);
  FileTimeToSystemTime(ft, st);
}
  SetDlgItemInt(hwnd, IDC_EDIT_YEAR, st.wYear, false);
  SetDlgItemInt(hwnd, IDC_EDIT_MONTH, st.wMonth, false);
  SetDlgItemInt(hwnd, IDC_EDIT_DAY, st.wDay, false);
  SetDlgItemInt(hwnd, IDC_EDIT_HOUR, st.wHour, false);
  SetDlgItemInt(hwnd, IDC_EDIT_MINUTE, st.wMinute, false);
  SetDlgItemInt(hwnd, IDC_EDIT_SECOND, st.wSecond, false);
end;

function ErrorLog(pw: PWideChar): BOOL; stdcall;
(*
  This function shows "errors" and information in the listbox IDC_LIST1
*)
begin
  result := True;
  SendDlgItemMessageW(hDlg, IDC_LIST1, LB_ADDSTRING, 0, Integer(pw));
  SendDlgItemMessageW(hDlg,
    IDC_LIST1,
    LB_SETTOPINDEX,
    SendDlgItemMessageW(hDlg, IDC_LIST1, LB_GETCOUNT, 0, 0) - 2,
    0);
end;

function WorkerThread(tdata: PThreadData): DWORD; stdcall;
(*
  This thread allows the application to start further actions for setting filetime
  while being busy (within an instance of this thread).
*)
begin
  result := 0;
// Set for all files in the directory
  ErrorLog(FormatW('[TID %6.6d] Here we go, I am a worker thread and I will do my job now.', [GetCurrentThreadID]));
  try
// Set time for the directory itself
    MySetFileTime(tdata^.Path, GetFileAttributesW(tdata^.Path), tdata^.ft, tdata^.la, tdata^.lw, tdata^.SpecialMode);
// Set time for the subdirectories and files
    RecurseDirAndSetTime('*', tdata^.Path, tdata^.ft, tdata^.la, tdata^.lw, tdata^.SpecialMode, tdata^.ShowAllFiles, @ErrorLog);
  finally
    ErrorLog(FormatW('[TID %6.6d] Finished my work.', [GetCurrentThreadID]));
// Free the buffers
    FreeMem(tdata^.Path);
    FreeMem(tdata);
    if not tdata^.ShowAllFiles then
      ErrorLog(FormatW('[TID %6.6d] If there are any file or directory names, there have been errors!', [GetCurrentThreadID]));
  end;
end;

procedure ApplyFiletimes(hwnd: HWND; ShowAllFiles, SpecialMode: Boolean);
(*
  Called by the window proc. It will prepare the data it got from the user to
  hand it over to the thread and then start the thread.
*)
var
  st: SYSTEMTIME;
  ft: FILETIME;
  trans: BOOL;
  tdata: PThreadData;
  pwc: PWideChar;
  i: Integer;
  _ft: FILETIME;
const
  prefix = '\\?\';
begin
// THERE ARE NO SANITY CHECKS FOR THE DATE/TIME INPUT DATA!!!
  ZeroMemory(@st, sizeof(st));
// Get the values
  st.wYear := GetDlgItemInt(hwnd, IDC_EDIT_YEAR, trans, false);
  st.wMonth := GetDlgItemInt(hwnd, IDC_EDIT_MONTH, trans, false);
  st.wDay := GetDlgItemInt(hwnd, IDC_EDIT_DAY, trans, false);
  st.wHour := GetDlgItemInt(hwnd, IDC_EDIT_HOUR, trans, false);
  st.wMinute := GetDlgItemInt(hwnd, IDC_EDIT_MINUTE, trans, false);
  st.wSecond := GetDlgItemInt(hwnd, IDC_EDIT_SECOND, trans, false);
  st.wMilliseconds := 0;
// Convert to filetime
  SystemTimeToFileTime(st, ft);
// Convert to local filetime
  LocalFiletimeToFileTime(ft, _ft);
// Set back into our structure to easily display the result
  FileTimeToSystemTime(_ft, st);
  if SpecialMode then
    ErrorLog('Special mode on. Will only reset file time (not date)!')
  else
    ErrorLog(FormatW('Found GMT time: %4.4d-%2.2d-%2.2d@%2.2d:%2.2d:%2.2d', [st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond]));
  ErrorLog('Filling data structure.');
// Allocate data structure for our thread
  GetMem(tdata, sizeof(tdata^));
  if Assigned(tdata) then
  try
// Filetimes to set
    CopyMemory(@tdata^.ft, @ft, sizeof(ft));
    CopyMemory(@tdata^.la, @ft, sizeof(ft));
    CopyMemory(@tdata^.lw, @ft, sizeof(ft));
// Get path to directory
    i := GetWindowTextLengthW(GetDlgItem(hwnd, IDC_EDIT_PATH)) + 2 + lstrlenW(prefix);
    GetMem(pwc, i * sizeof(WideChar));
    ZeroMemory(pwc, i * sizeof(WideChar));
    lstrcpyW(pwc, prefix);
// @pwc[lstrlenW(prefix)] is exactly the PWideChar starting after the prefix
    GetWindowTextW(GetDlgItem(hwnd, IDC_EDIT_PATH), @pwc[lstrlenW(prefix)], i);
    tdata^.Path := pwc;
    tdata^.ShowAllFiles := ShowAllFiles;
    tdata^.SpecialMode := SpecialMode;
// Start the thread
    ErrorLog('Starting worker thread.');
    CreateThread(nil, 0, @WorkerThread, tdata, 0, PDWORD(nil)^); // incompatible with Win9x!!!
  finally
  end
  else
    ErrorLog('Could not allocate memory!');
end;

procedure ShowHelp(hwnd: HWND);
var
  mbp: MSGBOXPARAMSW;
begin
  ZeroMemory(@mbp, sizeof(mbp));
  mbp.cbSize := sizeof(mbp);
  mbp.hwndOwner := hwnd;
  mbp.hInstance := hInstance;
  mbp.lpszIcon := MAKEINTRESOURCEW(IDI_ICON1);
  mbp.lpszCaption := 'FTchange - Short Help';
  mbp.lpszText := helptext;
  mbp.dwStyle := MB_USERICON;
  MessageBoxIndirectW(mbp);
end;

function DlgFunc(hwnd: HWND; umsg: UINT; wparam: WPARAM; lparam: LPARAM): BOOL; stdcall;
var
  st: SYSTEMTIME;
  ws: WideString;
begin
  Result := True;
  case umsg of
    WM_INITDIALOG:
      begin
        hDlg := hwnd;
// Set initial directory (e.g. for context menu)
        SetDlgItemTextW(hwnd, IDC_EDIT_PATH, 'C:\');
        if paramcount = 1 then
          if DirExists(paramstr(1)) then
          begin
            ErrorLog(@WideString(Format('Preset directory "%s"',[paramstr(1)]))[1]);
            SetDlgItemText(hwnd, IDC_EDIT_PATH, @paramstr(1)[1]);
          end;
// Set main icon
        SendMessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        SendMessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
// Set fixed font for all edit fields
        EnumChildWindows(hwnd, @EnumChildSetFonts, GetFont(hwnd, 8, FW_NORMAL, True));
        GetLocalTime(st);
        SetTimeInEdits(hwnd, st);
        CheckDlgButton(hwnd, IDC_CHECK_PROBLEMS, BST_CHECKED);
        Errorlog('Initialisation complete.');
      end;
    WM_CLOSE:
      EndDialog(hwnd, 0);
    WM_COMMAND:
      if HiWord(WParam) = BN_CLICKED then
        case LOWORD(wParam) of
          IDOK:
            ApplyFiletimes(
              hwnd,
              IsDlgButtonChecked(hwnd, IDC_CHECK_PROBLEMS) <> BST_CHECKED,
              IsDlgButtonChecked(hwnd, IDC_CHECK_SMODE) = BST_CHECKED
              );
          IDCANCEL:
            SendMessage(hwnd, WM_CLOSE, 0, 0);
          IDC_BUTTON_CHOOSEPATH:
            begin
              ws := BrowseForFolderW(hwnd, 'Please choose a folder to set the date inside!');
              if ws <> '' then
              begin
                SetDlgItemTextW(hwnd, IDC_EDIT_PATH, @ws[1]);
                ErrorLog(FormatW('Path chosen: %s', [ws]));
              end;
            end;
          IDC_BUTTON_CURRTIME,
            IDC_BUTTON_CURRMONTH,
            IDC_BUTTON_CURRYEAR:
            begin
              GetLocalTime(st);
              if (LOWORD(wParam) = IDC_BUTTON_CURRMONTH) or (LOWORD(wParam) = IDC_BUTTON_CURRYEAR) then
              begin
                st.wDay := 1;
                st.wHour := 0;
                st.wMinute := 0;
                st.wSecond := 0;
              end;
              if (LOWORD(wParam) = IDC_BUTTON_CURRYEAR) then
                st.wMonth := 1;
              SetTimeInEdits(hwnd, st);
              ErrorLog(FormatW('Preset time: %4.4d-%2.2d-%2.2d@%2.2d:%2.2d:%2.2d', [st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond]));
            end;
          IDC_BUTTON_HELP:
            ShowHelp(hwnd);
          IDC_CHECK_SMODE:
            if IsDlgButtonChecked(hwnd, IDC_CHECK_SMODE) = BST_CHECKED then
              MessageBox(hwnd,
                'This mode tries to reset the time only while leaving the date intact!'+#13#10#13#10+
                'It is not very reliable. Sometimes deviations occured during tests! (2 seconds usually ...)',
                'Information', 0);
        end;
    WM_SYSCOMMAND:
      case wParam of
        SC_CONTEXTHELP:
          ShowHelp(hwnd);
      else
        result := False;
      end;
  else
    result := False;
  end;
end;

begin
  appicon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
  DialogBoxParamW(hInstance, MAKEINTRESOURCEW(IDD_DIALOG1), 0, @dlgfunc, 0);
end.

